#include "MHora.h"

using namespace std;

namespace MHora
{
    // Compara las horas que se le pasa como parmetros
    TOrdenHora ComparaHora(THora hora1, THora hora2)
    {
        TOrdenHora comp;

        if (hora1.hora < hora2.hora)
        {
            comp = menor;
        }
        else if (hora1.hora > hora2.hora)
        {
            comp = mayor;
        }
        else if (hora1.minutos < hora2.minutos)
        {
            comp = menor;
        }
        else if (hora1.minutos > hora2.minutos)
        {
            comp = mayor;
        }
        else
        {
            comp = igual;
        }

        return comp;        
    }
    
    // Lee una hora desde teclado.
    void LeeHora(THora & hora)
    {
        bool correcto = true;
        
        do
        {
            cin >> hora.hora;
            cin.ignore();
            cin >> hora.minutos;
            cin.ignore();
            
            if (hora.hora < 0 || hora.hora > 23 || hora.minutos < 0 || hora.minutos > 59)
            {
                cout << "La hora no es correcta. Insrtela de nuevo:";
                correcto=false;
            }
        
        } while (!correcto);
    }
    
    // Escribe una hora por pantalla.
    void EscribeHora(THora hora)
    {
        cout << hora.hora << DP;
        if (hora.minutos < 10)
        {
            cout << "0";
        }
        cout << hora.minutos;
    }
    
    // Lee una hora desde un fichero de texto cuyo manejador se le pasa como parmetro.
    void LeeHoraFichero(ifstream &fich, THora& hora)
    {
        fich >> hora.hora;
        fich.ignore();
        fich >> hora.minutos;
    }
    
    // Escribe una hora en un fichero de texto cuyo manejador se le pasa como parmetro.
    void EscribeHoraFichero(ofstream & fich, THora hora)
    {
        fich << hora.hora << DP;
        if (hora.minutos < 10)
        {
            fich << "0";
        }
        fich << hora.minutos;
    }
    
}
