#ifndef _MHora_h_
#define _MHora_h_

#include <iostream>
#include <fstream>
#include <cstdlib>
#include "MError.h"

namespace MHora
{
    typedef enum {menor, igual, mayor} TOrdenHora;
    struct THora
    {
        unsigned int hora;
        unsigned int minutos;
    };
    
    const char DP = ':';
    
    TOrdenHora ComparaHora(THora hora1, THora hora2);
    // Compara las horas que se le pasa como parmetro
    void LeeHora(THora & hora);
    // Lee una hora desde teclado.
    void EscribeHora(THora hora);
    // Escribe una hora por pantalla.
    void LeeHoraFichero(ifstream &fich, THora& hora);
    // Lee una hora desde un fichero de texto cuyo manejador se le pasa como parmetro.
    void EscribeHoraFichero(ofstream & fich, THora hora);
    // Escribe una hora en un fichero de texto cuyo manejador se le pasa como parmetro.

}

#endif
