#include "MLista.h"

namespace MLista
{ 
    TLista CrearLista()
    {
        return NULL;   
    }
    
    bool ListaVacia(TLista l)
    {
        return (l==NULL);
    }    
    
    bool ListaLlena(TLista l)
    {
        bool esta_llena;
        TLista aux;
        
        aux = new (TNodo);
        esta_llena = (aux==NULL);
        
        if (!esta_llena)
        {
           delete(aux);             
        } 
        
        return esta_llena;   
    }
    
    void InsertarLista(TLista &l, TPeticion p, TError &error)
    {
         TLista nuevo;
         
         if (ListaLlena(l))
         {
             error = SinMemoria;              
         }
         else if (ListaVacia(l))
         {
                error = NoError;
                nuevo = new (TNodo);
                nuevo -> peticion = p;
                nuevo->sig = l;
                l=nuevo;
         }
         else if (ComparaHora(HoraInicio(p), HoraInicio(l->peticion)) == menor)
         {
                if (ComparaHora(HoraFin(p), HoraInicio(l->peticion))== mayor)
                {
                    error = ConflictoHorario;
                }
                else
                {
                    error = NoError;
                    nuevo = new (TNodo);
                    nuevo -> peticion = p;
                    nuevo->sig = l;
                    l=nuevo;
                }
         }
         else if ( ComparaHora(HoraInicio(p), HoraFin(l->peticion)) == menor )
         {
              error = ConflictoHorario;
         }
         else
         {
             InsertarLista(l->sig,p, error);
         }
         
    }
    
    void MostrarLista(TLista l)
    {
         TLista ptr;
         
         ptr=l;
         while (ptr!=NULL)
         {
               MostrarPeticion(ptr->peticion);
               ptr = ptr->sig;
         }
    }
    
    void BuscarLista(TLista l, THora hora, TPeticion &p, TError & error)
    {
        TLista ptr;
        bool encontrado;
        
        ptr = l;
        
        encontrado=false;
        while (!encontrado && ptr != NULL && ComparaHora(HoraInicio(ptr->peticion),hora)!=mayor)
        {
            encontrado = (ComparaHora(hora, HoraFin(ptr->peticion))==menor);
            p = ptr->peticion;
            ptr = ptr->sig;
        }
        
        if (encontrado)
        {
            error = NoError;
        }
        else
        {
            error = ErrorPeticionNoExiste;
        }
        
    }

    void EscribeListaFichero(TLista l, string nomFich, TError &error)
    {
        ofstream fich;
        TLista ptr;
        
        fich.open(nomFich.c_str());
        if ( fich.bad() || fich.fail() )
        {
             error = ErrorFichero;
        }
        else
        {
             ptr=l;
             while (ptr!=NULL)
             {
                   EscribePeticionFichero(fich, ptr->peticion);
                   ptr = ptr->sig;
             }
             fich.close();
             error=NoError;
        }
    }


    void LeeListaFichero(TLista &l, string nomFich, TError &error)
    {
        ifstream fich;
        TPeticion p;
        
        fich.open(nomFich.c_str());
        if ( fich.bad() || fich.fail() )
        {
             error = ErrorFichero;
        }
        else
        {
            LeePeticionFichero(fich, p);
            while (!fich.eof())
            {
                InsertarLista(l,p,error);
                LeePeticionFichero(fich, p);
            }
            fich.close();
            error=NoError;
        }
    }
       
    void DestruirLista(TLista &l)
    {
        TLista ptr;
         
        while (l!=NULL)
        {
              ptr=l;
              l = l->sig;
              delete(ptr);
        }
    }
    
}
