#include "MPeticion.h"

namespace MPeticion
{

    // Definiciones auxiliares
    typedef unsigned int TNatural;
    string Mayusculas(string s);
    void LeeInstrumento(TInstrumento &i);
    TInstrumento SUC(TInstrumento i);

    // Devuelve la cadena que representa a un instrumento.
    string Instrumento_a_Cadena(TInstrumento i)
    {
        string res;
        
        switch (i)
        {
            case osiris: res = "osiris"; break;
            case canaricam: res="canaricam"; break;
            case circe: res = "circe"; break;
            case emir: res = "emir"; break;
            case frida: res="frida"; break;
        }
        return res;
    }
    // Convierte, si es posible, una cadena en el instrumento al que representa.
    void Cadena_a_Instrumento(string s,TInstrumento & i, bool & ok)
    {
          ok = false;
          i = osiris;
          
          while ( (i<=frida) && (!ok) )
          {
                if (Mayusculas(s) == Mayusculas(Instrumento_a_Cadena(i)))
                {
                    ok = true;              
                }
                else
                {
                    i=SUC(i);
                }
          }
    }
    
    TInstrumento SUC(TInstrumento i)
    {
        return TInstrumento(TNatural(i)+1);   
    }
    
    // Muestra por pantalla una peticin.
    void MostrarPeticion(TPeticion p)
    {
        cout << "Investigador:" << p.investigador << endl;
        cout << "Hora de inicio:";
        EscribeHora(p.horaInicio);
        cout << endl;
        cout << "Hora de fin:";
        EscribeHora(p.horaFin);
        cout << endl;
        cout << "Instrumento:" << Instrumento_a_Cadena(p.instrumento) << endl;        
    }
    // Lee una peticin desde el teclado.
    void LeePeticion(TPeticion &p)
    {
        bool hora_ok;
        
        cout << "Investigador:";
        getline(cin, p.investigador, ENTER);
        
        do
        {
            cout << "Hora de inicio:";
            LeeHora(p.horaInicio);
            cout << "Hora de fin:";
            LeeHora(p.horaFin);
            
            hora_ok = (ComparaHora(p.horaInicio,p.horaFin)==menor);
            if (!hora_ok)
            {
                cout << "La hora de incicio no es menor que la de finalizacin" << endl;
            }
            
        } while (!hora_ok);
        
        LeeInstrumento (p.instrumento);
    }
    
    // Escribe la peticin en el fichero de texto  cuyo manejador se le pasa como parmetro.
    void EscribePeticionFichero(ofstream & fich, TPeticion p)
    {
        fich << p.investigador << ARROBA;
        EscribeHoraFichero(fich, p.horaInicio);
        fich << ARROBA;
        EscribeHoraFichero(fich, p.horaFin);
        fich << ARROBA;
        fich << Instrumento_a_Cadena(p.instrumento) << ENTER;
    }
    // Lee la peticin desde el fichero de texto  cuyo manejador se le pasa como parmetro.
    void LeePeticionFichero(ifstream & fich, TPeticion & p)
    {
        string s;
        bool ok;
        
        getline(fich, p.investigador,ARROBA);
        LeeHoraFichero(fich,p.horaInicio);
        fich.ignore();
        LeeHoraFichero(fich,p.horaFin);
        fich.ignore();
        getline(fich, s, ENTER);
        Cadena_a_Instrumento(s,p.instrumento, ok);
        
    }
    // Devuelve el nombre del investigador que realiz la peticin.
    string Investigador(TPeticion p)
    {
        return p.investigador;
    }
    // Devuelve la hora de inicio de la peticin.
    THora HoraInicio(TPeticion p)
    {
        return p.horaInicio;
    }
    
    // Devuelve la hora de fin de la peticin.
    THora HoraFin(TPeticion p)
    {
        return p.horaFin;
    }
    // Devuelve el intrumento necesario para la observacin.
    TInstrumento Instrumento(TPeticion p)
    {
        return p.instrumento;
    }
    
    // Procedimientos auxiliares
    
    string Mayusculas(string s) 
    {
        string res;
        int i;
        char c;
        
        res = "";
        
        for(i=0;i<s.length();++i)
        {
            c = toupper(s[i]);
            res+=c;                     
        }
        
        return res;
    }
     
    void LeeInstrumento( TInstrumento &i)
    {
        string s;
        bool ok;
     
        do
        {
            cout << "Instrumento: ";
            getline(cin,s,ENTER);
            Cadena_a_Instrumento(s, i, ok);
        } while (!ok);
    }

}
