#ifndef _MPeticion_h_
#define _MPeticion_h_

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include "MHora.h"

using namespace std;
using namespace MHora;

namespace MPeticion
{
    typedef enum {osiris, canaricam, circe, emir, frida} TInstrumento;
    struct TPeticion
    {
        string investigador;
        THora horaInicio;
        THora horaFin;
        TInstrumento instrumento;
    };
    
    const char ARROBA='@';
    const char ENTER = '\n';

    // Devuelve la cadena que representa a un instrumento.
    string Instrumento_a_Cadena(TInstrumento i);
    // Convierte, si es posible, una cadena en el instrumento al que representa.
    void Cadena_a_Instrumento(string s,TInstrumento & i, bool & ok);
    // Muestra por pantalla una peticin.
    void MostrarPeticion(TPeticion p);
    // Lee una peticin desde el teclado.
    void LeePeticion(TPeticion &p);
    // Escribe la peticin en el fichero de texto  cuyo manejador se le pasa como parmetro.
    void EscribePeticionFichero(ofstream & fich, TPeticion p);
    // Lee la peticin desde el fichero de texto  cuyo manejador se le pasa como parmetro.
    void LeePeticionFichero(ifstream & fich, TPeticion & p);
    // Devuelve el nombre del investigador que realiz la peticin.
    string Investigador(TPeticion p);
    // Devuelve la hora de inicio de la peticin.
    THora HoraInicio(TPeticion p);
    // Devuelve la hora de fin de la peticin.
    THora HoraFin(TPeticion p);
    // Devuelve el intrumento necesario para la observacin.
    TInstrumento Instrumento(TPeticion p);
    
}

#endif
